#include "Market.h"
#include <iostream>
#include <fstream>

using namespace std;

void Market::clearTrades(std::string fileName) {
	ofstream out;
	out.open(fileName);

	while (!buyOrders.isEmpty() && !sellOrders.isEmpty()) {
		Order* buy = buyOrders.front();
		Order* sell = sellOrders.front();
		int toBuy = buy->getAmount();
		int toSell = sell->getAmount();

		if (toBuy > toSell) {
			out << sell->getName() << " sells " << toSell << " units to " << buy->getName() << endl;
			buy->reduceAmount(toSell);
			sellOrders.dequeue();
			delete sell;
		}
		else if (toBuy == toSell) {
			out << sell->getName() << " sells " << toSell << " units to " << buy->getName() << endl;
			buyOrders.dequeue();
			delete buy;
			sellOrders.dequeue();
			delete sell;
		}
		else {
			out << sell->getName() << " sells " << toBuy << " units to " << buy->getName() << endl;
			buyOrders.dequeue();
			delete buy;
			sell->reduceAmount(toBuy);
		}
	}
	out.close();
}