template <typename T>
class Node {
public:
	Node<T>* link;
	T data;

	Node(T item) { link = nullptr;  data = item; }

	T getData() { return data; }
};

template <typename T>
class Queue {
private:
	Node<T>* head;
	Node<T>* tail;
public:
	Queue() { head = tail = nullptr; }

	// Add a new item to the tail of the queue
	void enqueue(T item) {
		if (head == nullptr) {
			head = tail = new Node<T>(item);
		}
		else {
			Node<T>* newNode = new Node<T>(item);
			tail->link = newNode;
			tail = newNode;
		}
	}

	// Remove the item at the head of the queue
	void dequeue() {
		if (head == nullptr)
			return;
		Node<T>* toRemove = head;
		head = head->link;
		if (head == nullptr)
			tail = nullptr;
		delete toRemove;
	}

	bool isEmpty() {
		return head == nullptr;
	}

	// Return the data item at the front of the queue
	T front() {
		return head->data;
	}
};